## questo e' il modulo dove definisco la classe agenti

import random


class agent:
      
      def __init__(self):

          ## le strategie sono oggetti che contengono gene, produzione etc.
          self.strategies = []
          for i in range(50):
                a = Strategies()
                self.strategies.append(a)

          ## prima strategia casuale
          self.strategy = self.strategies[random.randint(0, len(self.strategies)-1)]
          self.beta = 1 # random.gauss(1, 0.3)
          if self.beta <= 0: print self.beta, 'negative!!'          

      def computeFitnessProb(self, p, strategies, beta):
               'calcoliamo i fitness delle strategie ULTIMO PERIODO'

               
               for i in strategies:
                 i.fitness = p* i.y - 0.25 - beta * i.y**2 + 0.25 + beta
                 

               sumfit = 0
               for i in strategies:
                  sumfit += i.fitness

               for i in strategies:
                  i.probability = i.fitness*sumfit**-1

      ####### operatori genetici sugli oggetti strategia interni all'agente######

      def selection(self, strategies):
              random.shuffle(strategies)
              listaSelected = [] ## dove mettero' i geni selezionati selezionate
              listaProb = [] ## per ridurre i tempi di computazione, vedi prossimo for
              for i in strategies:
                  listaProb.append(i.probability)

              while len(listaSelected)<len(strategies):    
                    for i in strategies:
                        pr = random.uniform(0,max(listaProb))

                        if pr <= i.probability:
                           a = i.gene[:]
                           listaSelected.append(a)
                  
              while len(listaSelected)>len(strategies):
                        el = random.randint(0, len(listaSelected)-1)
                        del listaSelected[el]
              return listaSelected ## sono geni selezionati, li uso per il cross over e per la mutazione e alla fine aggiorno le strategie nell'agente

      def crossOver(self,listaSelected, crossp):

                  random.shuffle(listaSelected)
                  
                  for i in range(0, len(listaSelected), 2):
                        if random.uniform < crossp:
                             crosspoint = random.randint(0, 10)
                             gene1 = listaSelected[i][crosspoint:]
                             gene2 = listaSelected[i+1][crosspoint:]

                             listaSelected[i][crosspoint:]=gene2
                             listaSelected[i+1][crosspoint:] = gene1

                  return listaSelected

      def mutation(self, listaSelected, mutationp):

                  for i in range(len(listaSelected)):

                      for l in listaSelected[i]:

                        if random.uniform(0,1) < mutationp:

                              if l == 0:
                                 l = 1
                              else:
                                 l = 0
                  return listaSelected


      def updateStrategies(self,listaSelected, strategies):
                
                for i in range(len(strategies)):
                   ## i geni selezionati negli oggetti strategia
                   strategies[i].gene[:] = listaSelected[i][:]

                for i in strategies:
                    i.x = 0 ## x e' il valore della stringa convertito in decimali
                    for l in range(10):
                        i.x += i.gene[l]*2**(-l-1)                   

                    i.y=(5 * 5**-1) * i.x

                return strategies

          ############### DEVO SCEGLIERE UNA DELLE STRATEGIE!!!!, quella con il fitness piu' alto!####

      def chooseStrategy(self,p,strategies, beta):

                   
                    for i in strategies:
                       pr = random.random()
                       if pr <= i.probability:
                             self.strategy = i
                             break
                    




class Strategies:

      def __init__(self):
            self.gene = []
            for i in range(0,10):
                self.gene.append(random.randint(0,1))

            self.x = 0 ## x e' il valore della stringa convertito in decimali
            for l in range(10):
                self.x += self.gene[l]*2**(-l-1)


            self. y = (5 * 5**-1) * self.x
            self.fitness = 0
            self.probability = 0

            




